<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>

  <div class="container-fluid">
    <h3 class="text-center mt-3">
      Quản trị người dùng.
    </h3>
    <div class="row mb-5 bg-light p-5">
      <label for="" class="col-sm-3">Role</label>
      <select name="" id="select-role" class="col-sm-3 mr-5 form-control">
        <option value="0">Chọn Role</option>
      </select>
      <button id="btn-filter" class="btn btn-success col-sm-2">Lọc dữ liệu</button>
    </div>
    <table id="user-table" class="table table-bordered table-striped">
      <thead>
        <tr>
          <th>STT</th>
          <th>Username</th>
          <th>First name</th>
          <th>Lastname</th>
          <th>Email</th>
          <th>Age</th>
          <th>Role</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>

  <script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Mảng gUserObjects là mảng chứa dữ liệu users
    var gUserObjects = [
      {
        id: 2,
        username: "quannv",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        roleId: 5
      },
      {
        id: 3,
        username: "longdh",
        firstname: "Do Hoang",
        lastname: "Long",
        age: 19,
        email: "long@gmail.com",
        roleId: 8
      },
      {
        id: 4,
        username: "hiendt",
        firstname: "Do Thi",
        lastname: "Hien",
        age: 29,
        email: "hien@gmail.com",
        roleId: 11
      },
      {
        id: 6,
        username: "lanht",
        firstname: "Ho Thi",
        lastname: "Lan",
        age: 27,
        email: "lan@gmail.com",
        roleId: 13
      }
    ];
    // Mảng gRoleObjects là mảng chứa dữ liệu các roles
    var gRoleObjects = [
      {
        roleId: 5,
        roleName: "Admin"
      },
      {
        roleId: 8,
        roleName: "Manager"
      },
      {
        roleId: 11,
        roleName: "Teacher"
      },
      {
        roleId: 13,
        roleName: "Staff"
      }
    ];
    const gCOL_NAME = ["id", "username", "firstname", "lastname", "age", "email", "roleId", "action"];
    const gID_COL = 0;
    const gUSERNAME_COL = 1;
    const gFIRST_NAME_COL = 2;
    const gLAST_NAME_COL = 3;
    const gAGE_COL = 4;
    const gEMAIL_COL = 5;
    const gROLE_ID_COL = 6;
    const gACTION_COL = 7;
    var gStt = 1;

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();

      $("#btn-filter").on("click", function () {
        onBtnFilterData();
      })

      $("#user-table").on("click", ".dice-his", function () {
        getDataDice(this);
      })

    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      $("#user-table").DataTable({
        data: gUserObjects,
        columns: [
          { data: gCOL_NAME[gID_COL] },
          { data: gCOL_NAME[gUSERNAME_COL] },
          { data: gCOL_NAME[gFIRST_NAME_COL] },
          { data: gCOL_NAME[gLAST_NAME_COL] },
          { data: gCOL_NAME[gAGE_COL] },
          { data: gCOL_NAME[gEMAIL_COL] },
          { data: gCOL_NAME[gROLE_ID_COL] },
          { data: gCOL_NAME[gACTION_COL] },

        ],
        columnDefs: [
          {
            targets: gID_COL,
            render: chuyenId,
          },
          {
            targets: gROLE_ID_COL,
            render: getRoleNameById,
          },
          {
            targets: gACTION_COL,
            defaultContent: '<i  class="fas fa-dice mr-2 dice-his " title="Dice" style="color: #1d6df7;cursor:pointer"></i>' +
              '<i class="fas fa-gift" style="color: #1d6df7; cursor:pointer" title="Gift" ></i>'
          }
        ]
      })

      onPageLoadingSelectRole();

    }

    function onPageLoadingSelectRole() {
      for (var bI = 0; bI < gRoleObjects.length; bI++) {
        $("#select-role").append($("<option>", {
          value: gRoleObjects[bI].roleId,
          text: gRoleObjects[bI].roleName,
        }))
      }
    }

    function onBtnFilterData() {
      var vUserObj = {
        idRole: 0,
      }
      // b1 thu thập thông tin
      getDataUser(vUserObj);
      // b2 validate thông tin(bỏ qua)

      // b3 xử lý
      var vDataUser = filterDataRole(vUserObj);
      // b4 hiển thị
      displayUser(vDataUser);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function chuyenId() {
      return gStt++;
    }
    // thu thap thong tin

    function getDataUser(paramUser) {
      paramUser.idRole = $("#select-role").val();
    }
    // loc du lieu

    function filterDataRole(paramRole) {
      var vResult = [];
      vResult = gUserObjects.filter(function (item) {
        return item.roleId == paramRole.idRole;
      })
      return vResult;
    }
    // hien thi du lieu sau khi loc
    function displayUser(paramUser) {
      gStt = 1;
      var vTable = $("#user-table").DataTable();
      vTable.clear();
      vTable.rows.add(paramUser);
      vTable.draw();

    }
    //render role id thanh role name
    function getRoleNameById(paramData, paramType, paramRow) {
      "user strict"
      var vResultData = "";
      var vTimThay = false;
      var vIndex = 0;
      while (!vTimThay && vIndex < gRoleObjects.length) {
        if (gRoleObjects[vIndex].roleId == paramData) {
          vTimThay = true;
          vResultData = gRoleObjects[vIndex].roleName;
        }
        else {
          vIndex++;
        }

      }
      return vResultData;
    }
    // gán dữ liệu vào icon dice
    function getDataDice(paramElement) {
      var vTable = $("#user-table").DataTable();
      var vRow = paramElement.closest("tr");
      var vDataRow = vTable.row(vRow).data();
      console.log(vDataRow);
      var vLink = "diceHistory.html";
      window.location.href = vLink + "?username=" + vDataRow.username + "&firstname=" + vDataRow.firstname + "&lastname=" + vDataRow.lastname;
    }


  </script>
</body>

</html>